/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.misc;

import javax.annotation.Nonnull;

import net.minecraft.item.ItemStack;

public class ItemStackKey {
    public static final ItemStackKey EMPTY = new ItemStackKey(StackUtil.EMPTY);

    public final @Nonnull ItemStack baseStack;
    private final int hash;

    public ItemStackKey(@Nonnull ItemStack stack) {
        if (stack.func_190926_b()) {
            baseStack = StackUtil.EMPTY;
            hash = 0;
        } else {
            this.baseStack = stack.func_77946_l();
            this.hash = StackUtil.hash(baseStack);
        }
    }

    @Override
    public int hashCode() {
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == this) return true;
        if (obj == null) return false;
        if (obj.getClass() != this.getClass()) return false;
        ItemStackKey other = (ItemStackKey) obj;
        if (hash != other.hash) return false;
        if (baseStack.func_77973_b() != other.baseStack.func_77973_b()) {
            return false;
        }
        if (baseStack.func_77960_j() != other.baseStack.func_77960_j()) {
            return false;
        }
        return baseStack.serializeNBT().equals(other.baseStack.serializeNBT());
    }

    @Override
    public String toString() {
        return "[ItemStackKey " + baseStack + "]";
    }
}
